Index: zaptel.c
===================================================================
--- zaptel.c	(revision 2221)
+++ zaptel.c	(working copy)
@@ -4518,16 +4521,23 @@
 	span->flags &= ~ZT_FLAG_REGISTERED;
 	for (x=0;x<span->channels;x++)
 		zt_chan_unreg(&span->chans[x]);
-	maxspans = 0;
+	new_maxspans = 0;
+	new_master = master; /* FIXME: locking */
 	if (master == span)
-		master = NULL;
+		new_master = NULL;
 	for (x=1;x<ZT_MAX_SPANS;x++) {
 		if (spans[x]) {
-			maxspans = x+1;
-			if (!master)
-				master = spans[x];
+			new_maxspans = x+1;
+			if (!new_master)
+				new_master = spans[x];
 		}
 	}
+	maxspans = new_maxspans;
+	if (master != new_master)
+		if (debug)
+			printk("%s: Span ('%s') is new master\n", __FUNCTION__, 
+				(new_master)? new_master->name: "no master");
+	master = new_master;
 
 	return 0;
 }
